1. ./test-lib.sh
2
3if test -n "$NO_SVN_TESTS"
4then
5 test_expect_success 'skipping git-svn tests, NO_SVN_TESTS defined' :
6 test_done
7 exit
8fi
9
10GIT_DIR=$PWD/.git
11GIT_SVN_DIR=$GIT_DIR/svn/git-svn
12SVN_TREE=$GIT_SVN_DIR/svn-tree
13
14svn >/dev/null 2>&1
15if test $? -ne 1
16then
17 test_expect_success 'skipping git-svn tests, svn not found' :
18 test_done
19 exit
20fi
21
22svnrepo=$PWD/svnrepo
23
24perl -w -e "
25use SVN::Core;
26use SVN::Repos;
27\$SVN::Core::VERSION gt '1.1.0' or exit(42);
28system(qw/svnadmin create --fs-type fsfs/, '$svnrepo') == 0 or exit(41);
29" >&3 2>&4
30x=$?
31if test $x -ne 0
32then
33 if test $x -eq 42; then
34 err='Perl SVN libraries must be >= 1.1.0'
35 elif test $x -eq 41; then
36 err='svnadmin failed to create fsfs repository'
37 else
38 err='Perl SVN libraries not found or unusable, skipping test'
39 fi
40 test_expect_success "$err" :
41 test_done
42 exit
43fi
44
45rawsvnrepo="$svnrepo"
46svnrepo="file://$svnrepo"
47
48poke() {
49 test-chmtime +1 "$1"
50}
51
52for d in \
53 "$SVN_HTTPD_PATH" \
54 /usr/sbin/apache2 \
55 /usr/sbin/httpd \
56; do
57 if test -f "$d"
58 then
59 SVN_HTTPD_PATH="$d"
60 break
61 fi
62done
63for d in \
64 "$SVN_HTTPD_MODULE_PATH" \
65 /usr/lib/apache2/modules \
66 /usr/libexec/apache2 \
67; do
68 if test -d "$d"
69 then
70 SVN_HTTPD_MODULE_PATH="$d"
71 break
72 fi
73done
74
75start_httpd () {
76 if test -z "$SVN_HTTPD_PORT"
77 then
78 echo >&2 'SVN_HTTPD_PORT is not defined!'
79 return
80 fi
81
82 mkdir "$GIT_DIR"/logs
83
84 cat > "$GIT_DIR/httpd.conf" <<EOF
85ServerName "git-svn test"
86ServerRoot "$GIT_DIR"
87DocumentRoot "$GIT_DIR"
88PidFile "$GIT_DIR/httpd.pid"
89LockFile logs/accept.lock
90Listen 127.0.0.1:$SVN_HTTPD_PORT
91LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
92LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
93<Location /svn>
94 DAV svn
95 SVNPath $rawsvnrepo
96</Location>
97EOF
98 "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
99 svnrepo=http://127.0.0.1:$SVN_HTTPD_PORT/svn
100}
101
102stop_httpd () {
103 test -z "$SVN_HTTPD_PORT" && return
104 "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
105}
106
107convert_to_rev_db () {
108 perl -w -- - "$@" <<\EOF
109use strict;
110@ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
111open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
112open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
113my $size = (stat($rd))[7];
114($size % 24) == 0 or die "Inconsistent size: $size";
115while (sysread($rd, my $buf, 24) == 24) {
116 my ($r, $c) = unpack('NH40', $buf);
117 my $offset = $r * 41;
118 seek $wr, 0, 2 or die $!;
119 my $pos = tell $wr;
120 if ($pos < $offset) {
121 for (1 .. (($offset - $pos) / 41)) {
122 print $wr (('0' x 40),"\n") or die $!;
123 }
124 }
125 seek $wr, $offset, 0 or die $!;
126 print $wr $c,"\n" or die $!;
127}
128close $wr or die $!;
129close $rd or die $!;
130EOF
131}